%define url_ver %(echo %{version}|cut -d. -f1,2)

%define libapi 1
%define libmajor 0

Summary:	The Light Display Manager
Name:		lightdm
Version:	1.26.0
Release:	3
License:	GPLv3+
Group:		Graphical desktop/Other
Url:		http://www.freedesktop.org/wiki/Software/LightDM
Source0:	https://github.com/CanonicalLtd/lightdm/releases/download/%{version}/%{name}-%{version}.tar.xz
Source1:	29lightdm.conf
Source2:	Xsession
Source3:	lightdm-autologin.pam
Source4:	lightdm.pam
Source5:	lightdm-greeter.pam
#Systemd related:
Source10:	lightdm-tmpfiles.conf
Source11:	lightdm.service
Source12:	lightdm.rules
Patch0:		lightdm-1.16.7-rosa_config.patch
#Fedora patches
Patch11:	lightdm-1.11.7-nodaemon_option.patch
BuildRequires:	gnome-common
BuildRequires:	gtk-doc
BuildRequires:	intltool
BuildRequires:	itstool
BuildRequires:	systemd
BuildRequires:	yelp-tools
BuildRequires:	gettext-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(gio-2.0)
BuildRequires:	pkgconfig(gio-unix-2.0)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gobject-2.0)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(libgcrypt)
BuildRequires:	pkgconfig(libxklavier)
BuildRequires:	pkgconfig(QtCore) < 5.0.0
BuildRequires:	pkgconfig(QtDBus) < 5.0.0
BuildRequires:	pkgconfig(QtGui) < 5.0.0
%if 0
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5DBus)
BuildRequires:	pkgconfig(Qt5Gui)
%endif
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xcb)
BuildRequires:	pkgconfig(xdmcp)
Requires:	accountsservice
Requires:	typelib(LightDM)
Requires(post,preun,postun):	systemd
Requires(post,postun):	update-alternatives
Provides:	dm
Suggests:	lightdm-greeter
Suggests:	lightdm-gtk-greeter >= 1.6.1
Suggests:	numlock

%description
An X display manager that:
  * Has a lightweight codebase
  * Is standards compliant (PAM, etc)
  * Has a well defined interface between the server and user interface
  * Fully themeable (easiest with the webkit interface)
  * Cross-desktop (greeters can be written in any toolkit)

%files -f %{name}.lang
%dir %{_sysconfdir}/%{name}
%dir %{_localstatedir}/lib/%{name}
%dir %{_sysconfdir}/%{name}/lightdm.conf.d
%config %{_sysconfdir}/%{name}/lightdm.conf
%config %{_sysconfdir}/%{name}/users.conf
%config(noreplace) %{_sysconfdir}/%{name}/keys.conf
%ghost %{_localstatedir}/log/%{name}/%{name}.log
%{_bindir}/dm-tool
%{_sbindir}/%{name}
%{_sysconfdir}/%{name}/Xsession
%{_sysconfdir}/dbus-1/system.d/org.freedesktop.DisplayManager.conf
%{_sysconfdir}/pam.d/lightdm*
%{_datadir}/%{name}/
%{_datadir}/X11/dm.d/29lightdm.conf
%{_datadir}/accountsservice/interfaces/org.freedesktop.DisplayManager.AccountsService.xml
%{_datadir}/bash-completion/completions/*
%{_datadir}/dbus-1/interfaces/org.freedesktop.DisplayManager.AccountsService.xml
%{_datadir}/help/C/%{name}/
%{_datadir}/polkit-1/actions/org.freedesktop.DisplayManager.AccountsService.policy
%{_datadir}/polkit-1/rules.d/lightdm.rules
%{_libexecdir}/lightdm-guest-session
%{_prefix}/lib/tmpfiles.d/lightdm.conf
%{_unitdir}/lightdm.service
%{_mandir}/man1/%{name}*.1*
%{_mandir}/man1/dm-tool.*

%pre
%_pre_useradd %{name} %{_localstatedir}/lib/%{name} /sbin/nologin

%post
# avoiding conflict with gdm
if [ $1 -eq 1 ] ; then \
	update-alternatives --install %{_bindir}/gdmflexiserver gdmflexiserver %{_libexecdir}/%{name}/gdmflexiserver 30
fi

%create_ghostfile %{_localstatedir}/log/%{name}/%{name}.log %{name} %{name} 0644
%systemd_post %{name}.service

%preun
if [ $1 -ge 0 ] ; then \
	if [ ! -e %{_libexecdir}/%{name}/gdmflexiserver ]; then
		update-alternatives --remove gdmflexiserver %{_libexecdir}/%{name}/gdmflexiserver
	fi
fi
%systemd_preun %{name}.service

%postun
%_postun_userdel %{name}
%systemd_postun %{name}.service

#-------------------------------------------------------------------------

%define liblightdmgobject %mklibname lightdm-gobject %{libapi} %{libmajor}

%package -n %{liblightdmgobject}
Summary:	LightDM GObject client library
Group:		Graphical desktop/Other

%description -n %{liblightdmgobject}
A GObject based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmgobject}
%{_libdir}/liblightdm-gobject-%{libapi}.so.%{libmajor}
%{_libdir}/liblightdm-gobject-%{libapi}.so.%{libmajor}.*

#-------------------------------------------------------------------------

%define liblightdmgir %mklibname lightdm-gir %{libapi}

%package -n %{liblightdmgir}
Summary:	Typelib file for liblightdm-1
Group:		Graphical desktop/Other
Requires:	%{liblightdmgobject} = %{EVRD}

%description -n %{liblightdmgir}
A GObject based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmgir}
%{_libdir}/girepository-1.0/LightDM-%{libapi}.typelib

#-------------------------------------------------------------------------

%define liblightdmgobjectdevel %mklibname -d lightdm-gobject

%package -n %{liblightdmgobjectdevel}
Summary:	LightDM client library (development files)
Group:		Graphical desktop/Other
Requires:	%{liblightdmgobject} = %{EVRD}
Provides:	lightdm-gobject-devel = %{EVRD}

%description -n %{liblightdmgobjectdevel}
A GObject based library for LightDM clients to use to interface with LightDM.

This package contains header files and development information, which
is useful for building LightDM greeters and user switchers.

%files -n %{liblightdmgobjectdevel}
%doc %{_datadir}/gtk-doc/html/lightdm-gobject-%{libapi}
%{_includedir}/lightdm-gobject-%{libapi}/
%{_libdir}/liblightdm-gobject-%{libapi}.so
%{_libdir}/pkgconfig/liblightdm-gobject-%{libapi}.pc
%{_datadir}/gir-1.0/LightDM-%{libapi}.gir

#-------------------------------------------------------------------------

%define libqtapi 3
%define liblightdmqt %mklibname lightdm-qt %{libqtapi} %{libmajor}

%package -n %{liblightdmqt}
Summary:	LightDM Qt client library
Group:		Graphical desktop/Other

%description -n %{liblightdmqt}
A Qt based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmqt}
%{_libdir}/liblightdm-qt-%{libqtapi}.so.%{libmajor}
%{_libdir}/liblightdm-qt-%{libqtapi}.so.%{libmajor}.*

#-------------------------------------------------------------------------

%define liblightdmqtdevel %mklibname -d lightdm-qt

%package -n %{liblightdmqtdevel}
Summary:	LightDM client library (development files)
Group:		Graphical desktop/Other
Requires:	%{liblightdmqt} = %{EVRD}
Provides:	lightdm-qt-devel = %{EVRD}

%description -n %{liblightdmqtdevel}
A Qt based library for LightDM clients to use to interface with LightDM.

This package contains header files and development information, which
is useful for building LightDM greeters and user switchers.

%files -n %{liblightdmqtdevel}
%{_includedir}/lightdm-qt-%{libqtapi}
%{_libdir}/liblightdm-qt-%{libqtapi}.so
%{_libdir}/pkgconfig/liblightdm-qt-%{libqtapi}.pc

#-------------------------------------------------------------------------
%if 0
%define liblightdmqt5 %mklibname lightdm-qt5_ %{libqtapi} %{libmajor}

%package -n %{liblightdmqt5}
Summary:	LightDM Qt5 client library
Group:		Graphical desktop/Other
License:	LGPLv2+

%description -n %{liblightdmqt5}
A Qt5 based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmqt5}
%{_libdir}/liblightdm-qt5-%{libqtapi}.so.%{libmajor}
%{_libdir}/liblightdm-qt5-%{libqtapi}.so.%{libmajor}.*

#-------------------------------------------------------------------------

%define liblightdmqt5devel %mklibname -d lightdm-qt5

%package -n %{liblightdmqt5devel}
Summary:	LightDM client library (development files)
Group:		Graphical desktop/Other
License:	LGPLv2+
Requires:	%{liblightdmqt5} = %{EVRD}
Provides:	lightdm-qt5-devel = %{EVRD}

%description -n %{liblightdmqt5devel}
A Qt5 based library for LightDM clients to use to interface with LightDM.

This package contains header files and development information, which
is useful for building LightDM greeters and user switchers.

%files -n %{liblightdmqt5devel}
%{_includedir}/lightdm-qt5-%{libqtapi}
%{_libdir}/liblightdm-qt5-%{libqtapi}.so
%{_libdir}/pkgconfig/liblightdm-qt5-%{libqtapi}.pc
%endif

#-------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

%build
autoreconf -vfi
export PATH=$PATH:%{_qt4_bindir}
%configure2_5x \
	--disable-static \
	--disable-tests \
	--enable-introspection \
	--enable-liblightdm-gobject \
	--enable-liblightdm-qt \
	--with-greeter-session=lightdm-greeter
%make

%install
%makeinstall_std

## create/own these
mkdir -p %{buildroot}%{_sysconfdir}/lightdm/lightdm.conf.d
mkdir -p %{buildroot}%{_datadir}/lightdm/lightdm.conf.d

# install pam file
install -Dpm 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pam.d/%{name}-autologin
install -Dpm 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/pam.d/%{name}
install -Dpm 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/pam.d/%{name}-greeter

# dm config
install -Dpm644 %{SOURCE1} %{buildroot}/%{_datadir}/X11/dm.d/29lightdm.conf

# session wrapper script to source /etc/profile and ~/.profile if they exists
install -Dpm755 %{SOURCE2} %{buildroot}/%{_sysconfdir}/%{name}/Xsession

# will be created when lightdm starts
install -d %{buildroot}%{_localstatedir}/log/%{name}
touch %{buildroot}%{_localstatedir}/log/%{name}/%{name}.log

# directory for chksession-generated sessions
mkdir -p %{buildroot}%{_datadir}/%{name}/sessions
# directory for remote sessions
mkdir -p %{buildroot}%{_datadir}/%{name}/remote-sessions

install -Dpm 644 %{SOURCE10} %{buildroot}%{_prefix}/lib/tmpfiles.d/lightdm.conf
install -Dpm 644 %{SOURCE11} %{buildroot}%{_unitdir}/lightdm.service
install -Dpm 644 %{SOURCE12} %{buildroot}%{_datadir}/polkit-1/rules.d/lightdm.rules

#we don't want these
rm -rf %{buildroot}%{_sysconfdir}/apparmor.d
# omit upstart support
rm -rfv %{buildroot}%{_sysconfdir}/init

#home dir for lightdm user
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}

%find_lang %{name}

%changelog
